/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: setLogicalOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the setLogicalOperationDispatcher. It contains of all the generic methods
    for setLogicalOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setLogicalOperationDispatcher_HXX
#define setLogicalOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setLogicalOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setLogicalOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        setLogicalOperationDispatcher();
        virtual ~setLogicalOperationDispatcher();
        static OperationDispatcher *constructor();

 void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setLogicalPreConditions( Teamcenter::BusinessObject* obj, const bool boolValue, const bool isNull ) const;
    void setLogicalPreActions( Teamcenter::BusinessObject* obj, const bool boolValue, const bool isNull ) const;
    void setLogicalBaseAction( Teamcenter::BusinessObject* obj, const bool boolValue, const bool isNull ) const;
    void setLogicalPostActions( Teamcenter::BusinessObject* obj, const bool boolValue, const bool isNull ) const;

    // Project 011450 changes
    void setLogicalPreConditions( METHOD_message_t* msgData, const logical logicalValue, const logical isNull ) const;
    void setLogicalPreActions( METHOD_message_t* msgData, const logical logicalValue, const logical isNull ) const;
    void setLogicalPostActions( METHOD_message_t* msgData, const logical logicalValue, const logical isNull ) const;
    void setLogicalBaseAction( METHOD_message_t* msgData, const logical logicalValue, const logical isNull ) const;

    void setLogical( Teamcenter::BusinessObject* obj, const bool boolValue, const bool isNull ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setLogicalOperationDispatcher_HXX
